import _slicedToArray from "/home/oleggrishechkin/repositories/react-viewport-list/node_modules/@babel/runtime/helpers/esm/slicedToArray";
import React, { useMemo, useRef, useEffect, useState } from 'react';

var ViewPortList = function ViewPortList(_ref) {
  var _ref$viewPortRef = _ref.viewPortRef,
      viewPortRef = _ref$viewPortRef === void 0 ? React.createRef() : _ref$viewPortRef,
      _ref$elementsCount = _ref.elementsCount,
      elementsCount = _ref$elementsCount === void 0 ? 0 : _ref$elementsCount,
      _ref$elementHeight = _ref.elementHeight,
      elementHeight = _ref$elementHeight === void 0 ? 0 : _ref$elementHeight,
      _ref$margin = _ref.margin,
      margin = _ref$margin === void 0 ? 0 : _ref$margin,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? null : _ref$children;
  var ref = useRef(null);

  var _useState = useState([0, 0]),
      _useState2 = _slicedToArray(_useState, 2),
      _useState2$ = _slicedToArray(_useState2[0], 2),
      startIndex = _useState2$[0],
      endIndex = _useState2$[1],
      setIndexes = _useState2[1];

  var elementHeightWithMargin = elementHeight + margin;
  useEffect(function () {
    var frameId;

    var frame = function frame() {
      if (ref.current && viewPortRef.current) {
        setIndexes(function (currentIndexes) {
          var viewPortRect = viewPortRef.current.getBoundingClientRect();
          var minElementsCount = Math.min(Math.ceil(viewPortRect.height / elementHeightWithMargin), elementsCount);
          var nextStartIndex = Math.min(Math.max(Math.floor((viewPortRect.top - ref.current.getBoundingClientRect().top + currentIndexes[0] * elementHeightWithMargin) / elementHeightWithMargin), 0), elementsCount - minElementsCount);
          var nextEndIndex = Math.min(nextStartIndex + minElementsCount, elementsCount - 1);
          return nextStartIndex === currentIndexes[0] && nextEndIndex === currentIndexes[1] ? currentIndexes : [nextStartIndex, nextEndIndex];
        });
      }

      frameId = requestAnimationFrame(frame);
    };

    frame();
    return function () {
      return cancelAnimationFrame(frameId);
    };
  }, [elementHeightWithMargin, elementsCount, viewPortRef]);
  return useMemo(function () {
    if (!elementsCount || !children) {
      return false;
    }

    var result = [];

    for (var index = startIndex; index <= endIndex; ++index) {
      result.push(children({
        innerRef: index === startIndex ? ref : undefined,
        index: index,
        style: {
          marginTop: index === startIndex ? startIndex * elementHeightWithMargin : undefined,
          marginBottom: index === endIndex ? (elementsCount - 1 - endIndex) * elementHeightWithMargin : margin
        }
      }));
    }

    return result;
  }, [children, elementHeightWithMargin, elementsCount, endIndex, margin, startIndex]);
};

export default React.memo(ViewPortList);